import 'dart:async';
import 'dart:isolate';
import 'package:yona/yona.dart';

var host = NetAddr.fromString("yonafediverse.com:7777");

void main() async {
  var user = await Crypto.genSK();
  var rport = ReceivePort();
  rport.listen((message) => print(message));
  Isolate.spawn((map) async {
    var receiver = Client(MemCache(), (map as Map<String,dynamic>)["user"], host);
    await receiver.publish("client1", Duration(hours: 6));
    while (true) {
      await Future.delayed(Duration(milliseconds: 10));
      try {
        var msgs = await receiver.receive(10);
        for (var msg in msgs) {
          var diff = DateTime.now().difference(msg.data.sentAt).inMilliseconds /
              Duration.millisecondsPerSecond;
          (map)["port"].send("${Utils.parseBinaryToInt(msg.data.payload)}: $diff");
        }
      } catch (error) {
        print("error on receive $error");
      }
    }
  }, {"port":rport.sendPort,"user":user});
  await Future.delayed(Duration(seconds: 1));
  var sender = Client(MemCache(), await Crypto.genSK(), host);
  var i = 0;
  while (true) {
    await Future.delayed(Duration(milliseconds: 10));
    try {
      await sender.send(Crypto.derivePK(user), DateTime.now(), 1,
          Utils.int64ToBinary(++i), Duration(seconds: 1));
    } catch (error) {
      print("error on send $error");
    }
  }
}
