

class Pool<T> {
  final Set<T> _list = {};
  final T Function() _prod;
  final int cap;

  Pool(this.cap, this._prod) {
    if (cap <= 0) {
      throw Exception("cap is not positive");
    }
  }

  bool push(T t) {
    if (_list.length >= cap) {
      return false;
    }
    return _list.add(t);
  }

  T pull() {
    if (_list.isEmpty) {
      return _prod();
    }
    var first = _list.first;
    _list.remove(first);
    return first;
  }
}