
import 'package:test/scaffolding.dart';
import 'package:yona/yona.dart';

void main() async {
  test("node", () async {
    var host = NetAddr.fromString("yonafediverse.com:7777");
    var msg = Msg(DateTime.now(),100,await Crypto.randBytes(100));
    var user1 = await Crypto.genSK();
    var user2 = await Crypto.genSK();
    await Node.publish(user2, host, "user2",Duration(hours: 6));
    await Node.send(Duration(seconds: 2), user1, Send(Crypto.derivePK(user2), msg));
    var packets = await Node.receive(user2, host,10,[],Duration(seconds: 3));
    assert(packets.length == 1);
    assert(Utils.equal(packets[0].data.payload,msg.payload));
    assert(packets[0].data.kind == msg.kind);
    assert(packets[0].data.sentAt.millisecondsSinceEpoch == msg.sentAt.millisecondsSinceEpoch);
    assert(Utils.equal(packets[0].fromPublicKey, Crypto.derivePK(user1)));
    assert(!Utils.equal(packets[0].id,Packet.zeroID));
  });
}
